#include "UsbKeyboard.h"

// If the timer isr is corrected
// to not take so long change this to 0.
#define BYPASS_TIMER_ISR 1

int pressed_N = 0;
int pressed_NE = 0;
int pressed_E = 0;
int pressed_SE = 0;
int pressed_S = 0;
int pressed_SW = 0;
int pressed_W = 0;
int pressed_NW = 0;
int pressed_B = 0;
int pressed_0 = 1;
byte Jdirection = 0;
byte Jdirection_old = 0;

void setup(){
  //start serial connection
  Serial.begin(9600);
  //configure pin2 as an input and enable the internal pull-up resistor
  pinMode(8, INPUT_PULLUP);
  pinMode(9, INPUT_PULLUP);
  pinMode(10, INPUT_PULLUP);
  pinMode(11, INPUT_PULLUP);
  pinMode(12, INPUT_PULLUP);
  pinMode(13, OUTPUT);

  #if BYPASS_TIMER_ISR
    // disable timer 0 overflow interrupt (used for millis)
    TIMSK0&=!(1<<TOIE0); // ++
  #endif
}

#if BYPASS_TIMER_ISR
void delayMs(unsigned int ms) {
   /*
  */ 
  for (int i = 0; i < ms; i++) {
    delayMicroseconds(1000);
  }
}
#endif

void loop(){
  UsbKeyboard.update();
  
  //read the pushbutton value into a variable
  int sensorValN = digitalRead(8);
  int sensorValS = digitalRead(9);
  int sensorValW = digitalRead(10);
  int sensorValE = digitalRead(11);
  int sensorValB = digitalRead(12);
  //print out the value of the pushbutton
/*
  Serial.print(sensorValN);
  Serial.print(' ');
  Serial.print(sensorValS);
  Serial.print(' ');
  Serial.print(sensorValW);
  Serial.print(' ');
  Serial.print(sensorValE);
  Serial.print(' ');
  Serial.print(sensorValB);
  Serial.println(' ');
*/

  if (sensorValN && sensorValE && sensorValS && sensorValW && sensorValB && !pressed_0
    && (pressed_N || pressed_NE || pressed_E || pressed_SE || pressed_S 
    || pressed_SW || pressed_W || pressed_NW || pressed_B)){
      Jdirection = 0;
      UsbKeyboard.sendKeyUnPress(KEY_BSLASH);
      pressed_0 = 1;
  }
  
  if (sensorValN && pressed_N){
    Jdirection = 0;
    pressed_N = 0; pressed_NE = 0; pressed_E = 0; pressed_SE = 0; pressed_S = 0; pressed_SW = 0; pressed_W = 0; pressed_NW = 0;
  }
  if (sensorValN && sensorValE && pressed_NE){
    Jdirection = 0;
    pressed_N = 0; pressed_NE = 0; pressed_E = 0; pressed_SE = 0; pressed_S = 0; pressed_SW = 0; pressed_W = 0; pressed_NW = 0;
  }
  if (sensorValE && pressed_E){
    Jdirection = 0;
    pressed_N = 0; pressed_NE = 0; pressed_E = 0; pressed_SE = 0; pressed_S = 0; pressed_SW = 0; pressed_W = 0; pressed_NW = 0;
  }
  if (sensorValE && sensorValS && pressed_SE){
    Jdirection = 0;
    pressed_N = 0; pressed_NE = 0; pressed_E = 0; pressed_SE = 0; pressed_S = 0; pressed_SW = 0; pressed_W = 0; pressed_NW = 0;
  }
  if (sensorValS && pressed_S){
    Jdirection = 0;
    pressed_N = 0; pressed_NE = 0; pressed_E = 0; pressed_SE = 0; pressed_S = 0; pressed_SW = 0; pressed_W = 0; pressed_NW = 0;
  }
  if (sensorValS && sensorValW && pressed_SW){
    Jdirection = 0;
    pressed_N = 0; pressed_NE = 0; pressed_E = 0; pressed_SE = 0; pressed_S = 0; pressed_SW = 0; pressed_W = 0; pressed_NW = 0;
  }
  if (sensorValW && pressed_W){
    Jdirection = 0;
    pressed_N = 0; pressed_NE = 0; pressed_E = 0; pressed_SE = 0; pressed_S = 0; pressed_SW = 0; pressed_W = 0; pressed_NW = 0;
  }
  if (sensorValW && sensorValN && pressed_NW){
    Jdirection = 0;
    pressed_N = 0; pressed_NE = 0; pressed_E = 0; pressed_SE = 0; pressed_S = 0; pressed_SW = 0; pressed_W = 0; pressed_NW = 0;
  }
  if (sensorValB & pressed_B){
//    UsbKeyboard.sendKeyPress(KEY_BSLASH);
    pressed_B = 0;
    digitalWrite(13,LOW);
    UsbKeyboard.sendKeyUnPressTwo(Jdirection);
  }  
  
  //Selection scheme for determining the direction the joystick is pushed
  
  if (!sensorValN &&sensorValE && sensorValW && !pressed_N){
    Jdirection = (KEY_PAD_8);
    pressed_N = 1; pressed_NE = 0; pressed_E = 0; pressed_SE = 0; pressed_S = 0; pressed_SW = 0; pressed_W = 0; pressed_NW = 0;
    pressed_0 = 0;
  }
  if (!sensorValN && !sensorValE && !pressed_NE){
    Jdirection = (KEY_PAD_9);
    pressed_N = 0; pressed_NE = 1; pressed_E = 0; pressed_SE = 0; pressed_S = 0; pressed_SW = 0; pressed_W = 0; pressed_NW = 0;
    pressed_0 = 0;
  }
  if (!sensorValE && sensorValN && sensorValS && !pressed_E){
    Jdirection = (KEY_PAD_6);
    pressed_N = 0; pressed_NE = 0; pressed_E = 1; pressed_SE = 0; pressed_S = 0; pressed_SW = 0; pressed_W = 0; pressed_NW = 0;
    pressed_0 = 0;
  }
  if (!sensorValS && !sensorValE && !pressed_SE){
    Jdirection = (KEY_PAD_3);
    pressed_N = 0; pressed_NE = 0; pressed_E = 0; pressed_SE = 1; pressed_S = 0; pressed_SW = 0; pressed_W = 0; pressed_NW = 0;
    pressed_0 = 0;
  }
  if (!sensorValS && sensorValE && sensorValW && !pressed_S){
    Jdirection = (KEY_PAD_2);
    pressed_N = 0; pressed_NE = 0; pressed_E = 0; pressed_SE = 0; pressed_S = 1; pressed_SW = 0; pressed_W = 0; pressed_NW = 0;
    pressed_0 = 0;
  }
  if (!sensorValS && !sensorValW && !pressed_SW){
    Jdirection = (KEY_PAD_1);
    pressed_N = 0; pressed_NE = 0; pressed_E = 0; pressed_SE = 0; pressed_S = 0; pressed_SW = 1; pressed_W = 0; pressed_NW = 0;
    pressed_0 = 0;
  }
  if (!sensorValW && sensorValN && sensorValS && !pressed_W){
    Jdirection = (KEY_PAD_4);
    pressed_N = 0; pressed_NE = 0; pressed_E = 0; pressed_SE = 0; pressed_S = 0; pressed_SW = 0; pressed_W = 1; pressed_NW = 0;
    pressed_0 = 0;
  }
  if (!sensorValW && !sensorValN && !pressed_NW){
    Jdirection = (KEY_PAD_7);
    pressed_N = 0; pressed_NE = 0; pressed_E = 0; pressed_SE = 0; pressed_S = 0; pressed_SW = 0; pressed_W = 0; pressed_NW = 1;
    pressed_0 = 0;
  }
  if (!sensorValB & !pressed_B){
//    Jdirection = (KEY_PAD_5);
    pressed_B = 1;
    pressed_0 = 0;
    digitalWrite(13,HIGH);
  }
  
  if((Jdirection != Jdirection_old) && !pressed_B){
    if(Jdirection == 0)
      UsbKeyboard.sendKeyUnPress(Jdirection);
    else
      UsbKeyboard.sendKeyPress(Jdirection);
    Jdirection_old = Jdirection;
  }
  if(pressed_B){
    if(Jdirection == 0)
      UsbKeyboard.sendKeyPress(KEY_PAD_5);
    else
      UsbKeyboard.sendKeyPressTwo(Jdirection);
    Jdirection_old = Jdirection;
  }
//  delayMs(50);
}

